%%%% Anne Collins
%%%% LNCC, Brown University
%%%% 2012
%%%% Psych-review supplementary material
%%%% Cognitive control over learning: Creating, clustering and generalizing
%%%% Task-set structure


%%%% Task creation 


function input = createTask(taskNumber)


input = [];

if taskNumber == 1
    %%% initial advantage task

% number or actions
nA = 6;
% number of contexts
nS1 = 16;
% number of stims
nS2 = 3;
% input-correct action mapping
Actions =  [1 2 3 1 2 3 1 2 3 1 2 3 1 2 3 1 2 3 1 2 3 1 2 3 ...
    4 5 6 4 5 6 4 5 6 4 5 6 4 5 6 4 5 6 4 5 6 4 5 6 ];
% sequence of inputs
seq = Shuffle(repmat([1:nS1*nS2],1,25));

% correct action sequence
CAseq = 0 * seq;
for i = 1:nS1*nS2
    CAseq(seq == i) = Actions(i);
end
% noise sequence (if want to simulate task in probabilistic, get some non
% zeros in here)
noise = 0 * seq;

% context sequence
Cseq = floor((seq-1)/nS2) + 1;
% stimulus sequence
Sseq = rem(seq-1,nS2) + 1;

% save stuff
input.seq = seq;
input.cseq = Cseq;
input.sseq = Sseq;
input.CAseq = CAseq;
input.noise = noise;

elseif taskNumber == 2
    %%% experimental design task
nA=4;
nS1=4;
nS2=2;
Actions =   [1 2 3 4 1 2 1 4];
ActionsPC = [3 4 1 2 3 4 3 2];% error type NH/NC
ActionsPS = [2 1 4 3 2 1 4 1];% error type NL NS

seq=[repmat([1:4],1,30)];
Tis=randperm(length(seq));
seq=seq(Tis);
seq2=[repmat([5:8],1,20)];
Tis=randperm(length(seq2));
seq2=seq2(Tis);
seq = [seq seq2];


CAseq = 0 * seq;
HAseq = 0 * seq;% sequence of NH errors
LAseq = 0 * seq;% sequence of NL errors
noise = 0 * seq;

for i = 1:nS1*nS2
    CAseq(seq == i) = Actions(i);
    HAseq(seq == i) = ActionsPC(i);
    LAseq(seq == i) = ActionsPS(i);
end

Cseq = floor((seq-1)/nS2) + 1;
Sseq = rem(seq-1,nS2) + 1;

% save
input.seq = seq;
input.cseq = Cseq;
input.sseq = Sseq;
input.CAseq = CAseq;
input.HAseq = HAseq;
input.LAseq = LAseq;
input.noise = noise;


    
    
end

end